#include <Messenger.h>

#include "Messages.h"
#include "SNMPHit.h"
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
SNMPHit::SNMPHit(BString *string, int32 time, BMessenger * msgr)
 : CLVEasyItem()
{
  if( string->CountChars() > 11  ) { // This is not very good, but it will work for now
    struct tm *timeinfo;
    timeinfo = localtime ( &time ); 
    data << timeinfo->tm_mon + 1
         << "/" 
         << timeinfo->tm_mday
         << " "
         << timeinfo->tm_hour
         << ":";
    if( timeinfo->tm_min < 10 ) 
    data << "0";      
    data << timeinfo->tm_min
         << ":";
    if( timeinfo->tm_sec < 10 )         
    data << "0"; 
    data << timeinfo->tm_sec;
    
    
    
    SetColumnContent( 0, data.String() );
    string->MoveInto( data, 0, string->FindFirst( " " ) );
    if   ( data.Compare("out") == 0 ) { data.SetTo("Outbound"); msgr->SendMessage( new BMessage( OUTBOUND ) ); }
    else                              { data.SetTo("Inbound");  msgr->SendMessage( new BMessage( INBOUND ) ); }
    SetColumnContent( 1, data.String() );
    string->RemoveFirst(" "); 
    string->MoveInto( data, 0, string->FindFirst( " " )  );
    SetColumnContent( 2, data.String() );
    string->RemoveFirst(" "); 
    string->MoveInto( data, 0, string->FindFirst( " " )  );
    Port(&data);
    SetColumnContent( 3, data.String() );
    string->RemoveFirst(" "); 
    string->MoveInto( data, 0, string->FindFirst( " " )  );
    SetColumnContent( 4, data.String() );
    string->RemoveFirst(" "); 
    string->MoveInto( data, 0, string->FindFirst( "\n" ) );
    Port(&data);
    SetColumnContent( 5, data.String() );
  }
  delete msgr;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BString SNMPHit::String()
{
  BString String;
  for( int i = 0 ; i < 6 ; i++ ) {
    String.Append( GetColumnContentText(i) );
    String.Append( "\t" );
  }
  String.Append( "\n" );
  return String;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void SNMPHit::Port( BString *port)
{
       if( port->Compare("80")   == 0 ) { port->Append( " (http)"      ); }
  else if( port->Compare("21")   == 0 ) { port->Append( " (ftp)"       ); }
  else if( port->Compare("25")   == 0 ) { port->Append( " (smtp)"      ); }
  else if( port->Compare("110")  == 0 ) { port->Append( " (pop3)"      ); }
  else if( port->Compare("123")  == 0 ) { port->Append( " (ntp)"       ); }
  else if( port->Compare("194")  == 0 ) { port->Append( " (irc)"       ); }
  else if( port->Compare("23")   == 0 ) { port->Append( " (telnet)"    ); }
  else if( port->Compare("70")   == 0 ) { port->Append( " (gopher)"    ); }
  else if( port->Compare("79")   == 0 ) { port->Append( " (finger)"    ); }
  else if( port->Compare("161")  == 0 ) { port->Append( " (snmp)"      ); }
  else if( port->Compare("162")  == 0 ) { port->Append( " (snmp-trap)" ); }
  else if( port->Compare("443")  == 0 ) { port->Append( " (https)"     ); }
  else if( port->Compare("666")  == 0 ) { port->Append( " (doom)"      ); }
  else if( port->Compare("1080") == 0 ) { port->Append( " (socks)"     ); }
  else if( port->Compare("2009") == 0 ) { port->Append( " (news)"      ); }
  else if( port->Compare("7000") == 0 ) { port->Append( " (BShare)"      ); }
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
