#ifndef _DESKBAR_VIEW_H
#define _DESKBAR_VIEW_H

#include <NetEndpoint.h>
#include <PopUpMenu.h>
#include <View.h>

#include "LinkSysWindow.h"
class BBitmap;

class DeskbarView : public BView
{

public:

				DeskbarView();
				DeskbarView(BMessage *archive);
				
void			Draw(BRect rect);

static void		AddToDeskbar();
       void		RemoveFromDeskbar();
       void     MouseDown(BPoint);

       void     Pulse();
	
static			BArchivable *Instantiate(BMessage *data);
status_t		Archive(BMessage *data, bool deep = true) const;
private:
 BBitmap       *fBitmap;
 LinkSysWindow *window;
 BNetEndpoint  *endpoint;
 BPopUpMenu    *menu;
};


#endif
