#ifndef LINKSYSWINDOW_H
#define LINKSYSWINDOW_H
#include <Window.h>

#include "Santa/ColumnListView.h"

#include "IniFile/BIniFile.h"
#include <View.h>

class LinkSysWindow : public BWindow
{
public:
       LinkSysWindow();
  void MessageReceived( BMessage * );
  void SaveSettings();
  bool QuitRequested();
  void Quit();
private:
  CLVContainerView *mainView;
  ColumnListView   *listView;
  
  BMenuItem        *Logging;
  BMenuItem        *IActivate;
  BMenuItem        *ISound;
  
  BMenuItem        *OActivate;
  BMenuItem        *OSound;
  
  BFilePanel *saveBox;
  BIniFile *ini;
  BPath *Path;
};

#endif